<?php
 
 class CSS{
 
  var $css;
  var $filename;
  var $error;
  var $blockNo;
  var $locked;
  var $lockKi;
  
  var $sel;
  var $nonExtra;
  
  # constructor
  # -----------
  function CSS(){
   $this->clear();
   register_shutdown_function( array( &$this, "destroyCSS" ) );
   $this->ignored = array( 
    'block-number'
   );
   return;
  }
  
  # destructor
  # ----------
  function destroyCSS(){
   unset( $this->css );
   unset( $this->ignore );
   unset( $this->nonExtra ); 
   unset( $this->sel );
   return;
  }
  
  # clear
  # -----
  function clear(){
   unset( $this->css );
   $this->css = array();
   $this->nonExtra = array();
   $this->blockNo = 1;
   unset( $this->sel );
   $this->sel = array();
   return;
  }
  
  # select
  # ------
  function sel( $ki ){
   $this->unsel();
   $strcss = $this->cat( $ki, '' );
   $lines = explode( ';', $strcss );
   foreach( $lines as $line ){
    list( $ki, $prop ) = explode( ':', $line );
    $ki = trim( $ki );
    $prop = trim( $prop );
    $this->sel[$ki] = $prop;
   }
   return $strcss;
  }
  
  # unselect
  # --------
  function unsel(){
   unset( $this->sel );
   $this->sel = array();
   return;
  }
  
  # parseFile
  # ---------
  function parseFile( $cssFile = 'style.css' ){
   
   // Specified file does NOT exist
   if( !file_exists( $cssFile ) ){
    $this->error = 'Specified file does not exist.';
    return 1;
   }
   $this->filename = $cssFile;
   if( function_exists( "file_get_contents" ) ){
       $this->parseString( file_get_contents( $cssFile ) );
   }
   else{
       $cf = file( $cssFile );
       $entire_file = implode( '', $cf );
       $this->parseString( $entire_file );
   }
   $this->error = 'Success';
   return 0;
  }
  
  # setIgnoreList
  # -------------
  function setIgnoreList( &$newList ){
   unset( $this->nonExtra );
   $this->nonExtra = array();
   $this->nonExtra = $newList;
   return;
  }
  
  # LIST EXTRAS
  # -----------
  function listExtras( $ki ){
   $_class = $this->cat( $ki, '' );
   $all = explode( ';', $_class );
   $retVal = '';
   foreach( $all as $one ){
    list( $prop, $value ) = explode( ':', $one );
    $prop = trim( $prop );
    if( strlen( $prop ) != 0 AND !in_array( $prop, $this->nonExtra ) ){
     $retVal .= $prop.': '.trim( $value ).";\\n";
    }
   }
   return $retVal;
  }
  
  
  # get
  # ---
  function get( $ki ){
   return $this->sel[$ki];
  }
  
  
  # catalogue
  # ----------
  function cat( $ki, $property ) {
        
   list( $tag, $event ) = explode( ':', $ki );
   list( $tag, $cls ) = explode( '.', $tag );
   list( $tag, $id ) = explode( '#', $tag );
   $retval = '';
   $this->lockKi = '';
   
   $highestScore = 0; $bestBlock = 0;
   foreach( $this->css as $_tag => $_val ){
    list( $_tag, $_event ) = explode( ':', $_tag );
    list( $_tag, $_cls ) = explode( '.', $_tag );
    list( $_tag, $_id ) = explode( '#', $_tag );
    
    $score = 0;
    $tagsMatch = false;
    $classMatch = false;
    $eventsMatch = false;
    $idsMatch = false;
    
    // match tags
    if( strcmp( strtolower( $tag ), strtolower( $_tag ) ) == 0 && strlen( $tag ) != 0 ){
     $score += 10;
     $tagsMatch = true;
    }
    elseif( strlen( $_tag ) == 0 ){
     $tagsMatch = true;
    }
    
    // match class
    if( strcmp( $cls, $_cls ) == 0 && strlen( $cls ) != 0  ){
     $classMatch = true;
     $score += 10;
    }
    elseif( strlen( $_cls ) == 0 ){
     $classMatch = true;
    }
    
    // match event modifiers
    if( strcmp( $event, $_event ) == 0 && strlen( $event ) != 0  ){
     $eventsMatch = true;
     $score += 10;
    }
    elseif( strlen( $_event ) == 0 ){
     $eventsMatch = true;
     if( $tagsMatch && $classMatch && $score == 20 ) $score += 10;
    }
    
    // match ID
    if( strcmp( $id, $_id ) == 0 && strlen( $id ) != 0 ){
     $idsMatch = true;
     $score += 100;
    }
    elseif( strlen( $_id ) == 0 ){
     $idsMatch = true;
    }
    
    
    if( $score == 0 ) continue;
    if( $tagsMatch & $eventsMatch & $classMatch & $idsMatch ){
     $temp = $_tag;
     if( ( strlen( $temp ) > 0 ) & ( strlen( $_cls ) > 0 ) ){
      $temp .= '.'.$_cls;
     } 
     elseif( strlen( $temp ) == 0 ){
      $temp = ".".$_cls;
     }
     if( strlen( $_id ) != 0 ) $temp = '#'.$_id;
     if( ( strlen( $temp ) > 0 ) & ( strlen( $_event ) > 0 ) ){
      $temp .= ':'.$_event;
     } 
     elseif( strlen( $temp ) == 0 ){
      $temp = ':'.$_event;
     }
               
     // Return just the property
     if( $property ){
      if( isset( $this->css[$temp][$property] ) && $score >= $highestScore ){
       
       if( $score > $highestScore && $this->css[$temp]['block-number'] > $bestBlock ) $bestBlock = $this->css[$temp]['block-number'];
       if( $score == $highestScore ){
        if( $this->css[$temp]['block-number'] > $bestBlock ){
         $bestBlock = $this->css[$temp]['block-number'];
         $retval = $this->css[$temp][$property];
         $highestScore = $score;
         $this->lockKi = $temp." [$score]";
        }
       }
       else{
        $retval = $this->css[$temp][$property];
        $highestScore = $score;
        $this->lockKi = $temp." [$score]";
       }
       
      }
     }
     
     // Return the entire array of properties
     else{
      if( isset( $this->css[$temp] ) && $score >= $highestScore ){
       
       if( $score > $highestScore && $this->css[$temp]['block-number'] > $bestBlock ) $bestBlock = $this->css[$temp]['block-number'];
       if( $score == $highestScore ){
        if( $this->css[$temp]['block-number'] > $bestBlock ){
         $bestBlock = $this->css[$temp]['block-number'];
         $retval = '';
         foreach( $this->css[$temp] as $tmpProp => $tmpVal ){
          if( !in_array( $tmpProp, $this->ignored ) ){
           $retval .= ( $tmpProp.': '.$tmpVal.'; ' );
          }
         }
         $highestScore = $score;
         $this->lockKi = $temp." [$score]";
        }
       }
       else{
        $retval = '';
        foreach( $this->css[$temp] as $tmpProp => $tmpVal ){
         if( !in_array( $tmpProp, $this->ignored ) ){
          $retval .= ( $tmpProp.': '.$tmpVal.'; ' );
         }
        }
        $highestScore = $score;
        $this->lockKi = $temp." [$score]";
       }
      } 
     } //END: what to return
     
    }
   }
   return $retval;
  }
    
  # dump
  # ----
  function dump(){
   var_dump( $this->css );
   return;
  }
  
  # add
  # ---
  function add( $ki, $strProps, $block = 0 ){
   
   $props = explode( ';', $strProps );
   if( count( $props ) > 0 ){
    foreach( $props as $prop ){
     $prop = trim( $prop );
     list( $pName, $pVal ) = explode( ':', $prop );
     if( strlen( $pName ) > 0 ){
      
      # uppercase the TAG if exists
      if( strpos( $ki, '.' ) !== false ){
        list( $tag, $rest ) = explode( '.', $ki );
        $ki = strtoupper( trim( $tag ) ).'.'.$rest;
      }
      
      if( !isset( $this->css[ $ki ] ) ) $this->css[ $ki ] = array();
      $this->css[ $ki ][ trim( $pName ) ] = trim( $pVal );
      $this->css[ $ki ][ 'block-number' ] = $block;
     }
    }
   }
   $this->error = 'OK';
   return 0;
  }
  
  # parseString
  # -----------
  function parseString( $str = '' ){
   
   // 1. Ignore comments
   $str = preg_replace( "/\/\*(.*)?\*\//Usi", "", $str );
   
   // 2. Count number of elements
   $blocks = explode( '}', $str );
   if( count( $blocks ) > 0 ){
    foreach( $blocks as $block ){
     list( $strKeys, $strProps ) = explode( '{', $block );
     $keys = explode( ',', trim( $strKeys ) );
     if( count( $keys ) > 0 ){
      
      foreach( $keys as $ki ) {
       $ki = trim( $ki );
       if( strlen( $ki ) > 0 ) {
        $ki = str_replace( "\n", '', $ki );
        $ki = str_replace( "\\", '', $ki );
        $this->add( $ki, trim( $strProps ), $this->blockNo );
       }
      } // END: each ki$
     } // END: count $keys
     $this->blockNo++;
    } // END: each $block
   } // END: count $block  
   return;
  }
  
  
  # delete
  # ------
  function delete( $ki ){
   
   # uppercase the TAG if exists
   if( strpos( $ki, '.' ) !== false ){
    list( $tag, $rest ) = explode( '.', $ki );
    $ki = strtoupper( trim( $tag ) ).'.'.$rest;
   }
   
   if( $this->css[$ki] ){
    unset( $this->css[$ki] );
   }
   else{
    error_log( "SaveCSS.php was not able to delete an \$fss key named '$ki'", E_USER_NOTICE );
   }
   
   return;
  }
  
  
  # getCSS
  # -------
  function getCSS() {
   $result = '';
   foreach( $this->css as $ki => $values ) {
    $result .= $ki." {\n";
    foreach( $values as $ki => $value) {
     if( !in_array( $ki, $this->ignored ) ){
      $result .= " $ki: $value;\n";
     }
    }
    $result .= "}\n\n";
   }
   return $result;
  }
  
  # packCSS
  # -------
  function getPackedCSS(){
   
   $titles = array();
   
   foreach( $this->css as $ki => $value ){
    
    list( $tag, $event ) = explode( ':', $ki );
    list( $tag, $cls ) = explode( '.', $tag );
    list( $tag, $id ) = explode( '#', $tag );
    $masterKi = $tag.'.'.$cls;
    if( $id ) $masterKi = $tag.'#'.$id;
    
    if( !$titles[ $masterKi ] ) $titles[ $masterKi ] = $masterKi;
    
    if( $ki != $masterKi ){
     
     // delete the black-number
     unset( $this->css[$ki]['block-number'] );
     
     // go throught props 
     foreach( $this->css[$ki] as $pname => $pv ){
      $pname = trim( $pname );
      if( in_array( $pname, $this->ignored ) ) continue;
      $pv = trim( $pv );
      if( $this->css[$ki][$pname] == $this->css[$masterKi][$pname] ){
       unset( $this->css[$ki][$pname] );
      }
     }
    }
    
    // This is an empty key
    if( count( $this->css[$ki] ) == 0 ){
     unset( $this->css[$ki] );
     $titles[ $masterKi ] .= ", $ki";
    }
    else{
     $titles[$ki] = $ki;
    }
   }
   
   $result = '';
   foreach( $this->css as $ki => $values ) {
    $result .= $titles[$ki]." {\n";
    foreach( $values as $ki => $value) {
     if( in_array( $ki, $this->ignored ) ) continue;
     $result .= " $ki: $value;\n";
    }
    $result .= "}\n\n";
   }
   $this->clear();
   return $result;
  }
  
 } // END: class definition

?>