<?php
 error_reporting( E_ALL ^ E_NOTICE );
 include_once "./cssparser.php";

 $updateId  = urldecode( $_REQUEST[ 'id' ] );
 $editType  = urldecode( $_REQUEST[ 'edittype' ] );
 $classOrId = urldecode( $_REQUEST[ 'classorid' ] );
 $classType = urldecode( $_REQUEST[ 'classType' ] );
 $className = urldecode( $_REQUEST[ 'classname' ] );
 $subClass  = urldecode( $_REQUEST[ 'subclass' ] );
 $skinName  = urldecode( $_REQUEST[ 'skin' ] );

 $css = NEW CSS();
 $css->parseFile( "../../../skins/$skinName/skin.css" );
 
 $tagEvents = array(
  'body' => array( 'normal' ),
  'font' => array( 'normal' ),
  'a' => array( 'normal', 'hover', 'active', 'visited' ),
  'div' => array( 'normal', 'hover' ),
  'textbox' => array( 'normal', 'hover', 'active' ),
  'submit' => array( 'normal', 'hover', 'active' )
 );
 
 $events = array();
 foreach( $tagEvents[ $editType ] as $tmpEvent ){
  $events[ $tmpEvent ] = ":$tmpEvent";
 }
 
 $eventList = array();
 $eventList = $tagEvents[ $editType ];
 
   
 // Border types
 $borderTypes = array(
  "Left"   => 'left',
  "Right"  => 'right',
  "Top"    => 'top',
  "Bottom" => 'bottom'
 );

 $borders = array(
  'left' => array( 'color' => '', style => '', width => '' ),
  'right' => array( 'color' => '', style => '', width => '' ),
  'top' => array( 'color' => '', style => '', width => '' ),
  'bottom' => array( 'color' => '', style => '', width => '' ),
  'all' => array( 'color' => '', style => '', width => '' )
 );
 
 // Extra field ignore list
 $ignoredKeys = array(
  "font-family",
  "font-size",
  "font-weight",
  "font-style",
  "text-decoration",
  "color",
  "background-color",
  "cursor",
  "border-left",
  "border-left-color",
  "border-left-style",
  "border-left-width",
  "border-right",
  "border-right-color",
  "border-right-style",
  "border-right-width",
  "border-top",
  "border-top-color",
  "border-top-style",
  "border-top-width",
  "border-bottom",
  "border-bottom-color",
  "border-bottom-style",
  "border-bottom-width",
  "border",
  "border-color",
  "border-style",
  "border-width"
 );
 
 $jscss = array(); 
 foreach( $events as $event => $eTag ) {
  $jscss[ $event ] = array();
  
  // selected class definition
  switch( $classOrId ){
   case 'class':
    $sdName = "$subClass.$className".$eTag;
    break;
   
   case 'tag':
    $sdName = $className.$eTag;
    break;
   
   case 'id':
    $sdName = "#$className".$eTag;
    break;
  }
  
  $css->sel( $sdName );
  $jscss[ $event ][ 'cDef' ] = str_replace( "\n", '', $css->lockKi." => ".trim( $css->cat( $sdName, '' ) ) );
  
  
  # DO THE PARSING
  # **************
  $css->setIgnoreList( $ignoredKeys ); 
  $jscss[ $event ][ 'extra' ] = $css->listExtras( $sdName );
  
  # FONT: Name, Size, Units
  # -----------------------
  list( $firstFont ) = explode( ',', $css->get( 'font-family' ) );
  list( $fontSize, $fontSizeUnit) = explode( " ", preg_replace( "/(\d+)/", "\$1 ", $css->get( 'font-size' ) ) );
  
  $jscss[ $event ][ 'font-family' ] = trim( str_replace( '"', '', $firstFont ) );
  $jscss[ $event ][ 'font-size' ] = trim( $fontSize );
  $jscss[ $event ][ 'font-size-unit' ] = strtolower( trim( $fontSizeUnit ) );
 
  // Bold, Italic, Underlined
  if( $css->get( 'font-weight' ) == 'bold' ) $jscss[ $event ][ 'font-bold' ] = 'checked';
  if( $css->get( 'font-style' ) == 'italic' ) $jscss[ $event ][ 'font-italic' ] = 'checked';
  if( $css->get( 'text-decoration' ) == 'underline' ) $jscss[ $event ][ 'font-underline' ] = 'checked';
  
  # COLOR
  # -----
  $jscss[ $event ][ 'color' ] = $css->get( 'color' );
  $jscss[ $event ][ 'background-color' ] = $css->get( 'background-color' );

  # MOUSE CURSOR
  # ------------
  $cursor = $css->get( 'cursor' );
  if( !$cursor ) $cursor = '';
  $jscss[ $event ][ 'cursor' ] = $cursor;
  
  # BORDERS
  # -------
  foreach( $borderTypes as $bt => $btval ){
   if( $css->get( "border-$btval" ) ){
    $cssval = explode( " ", $css->get( "border-$btval" ) );
    $jscss[ $event ][ "border-$btval" ] = array();
    $jscss[ $event ][ "border-$btval" ]['color'] = $cssval[ 0 ];
    $jscss[ $event ][ "border-$btval" ]['style'] = $cssval[ 1 ];
    $jscss[ $event ][ "border-$btval" ]['width'] = $cssval[ 2 ] * 1;
   }
  }
 
  // Parse border ALL
  if( $css->get( "border" ) ){
   $cssval = explode( " ", $css->get( "border" ) );
   $jscss[ $event ][ 'border' ] = array();
   $jscss[ $event ][ 'border' ]['color'] = $cssval[ 0 ];
   $jscss[ $event ][ 'border' ]['style'] = $cssval[ 1 ];
   $jscss[ $event ][ 'border' ]['width'] = $cssval[ 2 ] * 1;
  }
  
  
  // These are the default 1st page values
  if( $event == 'normal' ){
   
   // Decide which border type radio button to check
   if( $css->get( 'border' ) ){
    $selBorderAll = 'yes';
   }
   if( $css->get( 'border-left' ) || $css->get( 'border-right' ) || $css->get( 'border-top' ) || $css->get( 'border-bottom' ) ){
    $selBorderSingle = 'yes';
   }
     
  } // END: default 1st page stuff
  
  
 } // END: loop through events
 
 // var_dump( $jscss['hover'] );
 // exit;
 
 
 $fonts = array(
  "Arial"     => 'Arial',
  "Tahoma"    => 'Tahoma',
  "Verdana"   => 'Verdana',
  "Helvetica" => 'Helvetica',
  "Courier"   => 'Courier New',
  "Trebuchet" => 'Trebuchet MS'
 );

 
 
 $borderStyles = array(
  "none"   => "none",  
  "solid"  => "solid",
  "double" => "double",
  "---------" => "none",
  "dotted" => "dotted",
  "dashed" => "dashed",
  "inset"  => "inset", 
  "outset" => "outset",
  "ridge"  => "ridge", 
  "groove" => "groove"
 );


 // Cursor pointers
 $cursorPointres = array(
  "Auto"      => '',
  "Default"   => 'default',
  "Pointer"   => 'pointer',
  "---------" => 'Auto',
  "Move"      => 'move',
  "Text"      => 'text',
  "Wait"      => 'wait',
  "Help"      => 'help',
  "---------" => 'Auto',
  "E-resize"  => 'e-resize',
  "NE-resize" => 'ne-resize',
  "NW-resize" => 'nw-resize',
  "N-resize"  => 'n-resize',
  "SE-resize" => 'se-resize',
  "SW-resize" => 'sw-resize',
  "S-resize"  => 's-resize',
  "W-resize"  => 'w-resize',
  "Progress"  => 'progress',
  "Crosshair" => 'crosshair'
 );


 // Decide which DIVS to allow
 $displayGeneralDiv = true;
 $displayBordersDiv = true;
 $displayExtraDiv = true;
 $displayDebugDiv = true;
 if( $editType == 'font' ){
  $displayBordersDiv = false;
 }

 
?>
<HTML>
 <HEAD>
  <SCRIPT src="./flooble.js" type="text/javascript"></SCRIPT>
  <SCRIPT src="./div.js" type="text/javascript"></SCRIPT>

  <SCRIPT type="text/javascript">
  <!--
   var css = Array();
   var event = 'normal';
   var events = Array( 'normal'<?php 
    foreach( $events as $event => $eTag ){ 
     if( $event == 'normal' ) continue;
     echo ",\n'".$event."'";
    } ?>
   );
   
   <?php foreach( $events as $event => $eTag ){ ?>
     
    var tmpe = '<?php echo $event; ?>';
    css[ tmpe ] = Array();
    css[ tmpe ]['font-family'] = '<?php echo $jscss[$event][ 'font-family' ]; ?>';
    css[ tmpe ]['font-size'] = '<?php echo $jscss[$event][ 'font-size' ]; ?>';
    css[ tmpe ]['font-size-unit'] = '<?php echo $jscss[$event][ 'font-size-unit' ]; ?>';
    css[ tmpe ]['font-bold'] = '<?php echo $jscss[$event][ 'font-bold' ]; ?>';
    css[ tmpe ]['font-italic'] = '<?php echo $jscss[$event][ 'font-italic' ]; ?>';
    css[ tmpe ]['font-underline'] = '<?php echo $jscss[$event][ 'font-underline' ]; ?>';
    css[ tmpe ]['color'] = '<?php echo $jscss[$event][ 'color' ]; ?>';
    css[ tmpe ]['background-color'] = '<?php echo $jscss[$event][ 'background-color' ]; ?>';
    css[ tmpe ]['cursor'] = '<?php echo $jscss[$event][ 'cursor' ]; ?>';
    
    css[ tmpe ]['border'] = Array();
    css[ tmpe ]['border']['color'] = '<?php echo $jscss[$event]['border']['color']; ?>';
    css[ tmpe ]['border']['width'] = '<?php echo $jscss[$event]['border']['width']; ?>';
    css[ tmpe ]['border']['style'] = '<?php echo $jscss[$event]['border']['style']; ?>';
    
    css[ tmpe ]['border-left'] = Array();
    css[ tmpe ]['border-left']['color'] = '<?php echo $jscss[$event]['border-left']['color']; ?>';
    css[ tmpe ]['border-left']['width'] = '<?php echo $jscss[$event]['border-left']['width']; ?>';
    css[ tmpe ]['border-left']['style'] = '<?php echo $jscss[$event]['border-left']['style']; ?>';
    
    css[ tmpe ]['border-right'] = Array();
    css[ tmpe ]['border-right']['color'] = '<?php echo $jscss[$event]['border-right']['color']; ?>';
    css[ tmpe ]['border-right']['width'] = '<?php echo $jscss[$event]['border-right']['width']; ?>';
    css[ tmpe ]['border-right']['style'] = '<?php echo $jscss[$event]['border-right']['style']; ?>';
    
    css[ tmpe ]['border-top'] = Array();
    css[ tmpe ]['border-top']['color'] = '<?php echo $jscss[$event]['border-top']['color']; ?>';
    css[ tmpe ]['border-top']['width'] = '<?php echo $jscss[$event]['border-top']['width']; ?>';
    css[ tmpe ]['border-top']['style'] = '<?php echo $jscss[$event]['border-top']['style']; ?>';
    
    css[ tmpe ]['border-bottom'] = Array();
    css[ tmpe ]['border-bottom']['color'] = '<?php echo $jscss[$event]['border-bottom']['color']; ?>';
    css[ tmpe ]['border-bottom']['width'] = '<?php echo $jscss[$event]['border-bottom']['width']; ?>';
    css[ tmpe ]['border-bottom']['style'] = '<?php echo $jscss[$event]['border-bottom']['style']; ?>';
    
    css[ tmpe ][ 'single' ] = 0;
    
    <?php if( $jscss[$event]['border-left']['style'] || $jscss[$event]['border-top']['style'] || $jscss[$event]['border-right']['style'] || $jscss[$event]['border-bottom']['style'] ){ ?>
    css[ tmpe ][ 'single' ] = 1;
    <?php } ?>
    
    css[ event ][ 'all' ] = 0;
    <?php if( $jscss[$event]['border']['style'] ){ ?>
    css[ tmpe ][ 'all' ] = 1;
    <?php } ?>
    
    
    // page 0, 3
    css[ tmpe ]['extra'] = '<?php echo addslashes( $jscss[$event][ 'extra' ]); ?>';
    css[ tmpe ]['cDef'] = '<?php echo addslashes( $jscss[$event][ 'cDef' ]); ?>';
    
   <?php } ?>
   
    // go through css array and copy normal event values to other events if values undefined
    props = new Array(
     'font-family',
     'font-size',
     'font-size-unit',
     'font-bold',
     'font-italic',
     'font-underline',
     'color',
     'background-color',
     'cursor',
     'all',
     'single',
     'border-left',
     'border-right',
     'border-top',
     'border-bottom'
    );
    
    for( ei in events ){
     tmpe = events[ ei ];
     if( tmpe == 'normal' ) continue;
     if( !css[tmpe] ){
      continue;
     }
     
     for( pi in props ){
      prop = props[ pi ];
      if( !css[tmpe][prop] ) css[tmpe][prop] = css['normal'][prop];
     }
     
    }
   
   
   // Save Event Values
   // -----------------
   function saveEventValues(){ 
    
    css[ event ][ 'font-family' ] = document.getElementById( 'fontFamily' ).value;
    css[ event ][ 'font-size' ] = document.getElementById( 'fontSize' ).value;
    css[ event ][ 'font-size-unit' ] = document.getElementById( 'sizeUnit' ).value;
    
    css[ event ][ 'font-bold' ] = 0;
    css[ event ][ 'font-italic' ] = 0;
    css[ event ][ 'font-underline' ] = 0;
    if( document.getElementById( 'fontBold' ).checked ) css[ event ][ 'font-bold' ] = 'checked';
    if( document.getElementById( 'fontItalic' ).checked ) css[ event ][ 'font-italic' ] = 'checked';
    if( document.getElementById( 'fontUnderlined' ).checked ) css[ event ][ 'font-underline' ] = 'checked';
    
    css[ event ][ 'color' ] = document.getElementById( 'foregroundfield' ).value;
    css[ event ][ 'background-color' ] = document.getElementById( 'backgroundfield' ).value;
    css[ event ][ 'cursor' ] = document.getElementById( 'cursor' ).value;
    
    css[ event ][ 'all' ] = 0;
    css[ event ][ 'single' ] = 0;
    if( document.getElementById( 'optAll' ).checked ) css[ event ][ 'all' ] = 1;
    if( document.getElementById( 'optSingle' ).checked) css[ event ][ 'single' ] = 1;
        
    // Left border
    if( !document.getElementById( 'borderLeft' ).checked ){
     css[ event ][ 'border-left' ][ 'style' ] = '';
     css[ event ][ 'border-left' ][ 'color' ] = '';
     css[ event ][ 'border-left' ][ 'width' ] = '';
    }
    else{
     css[ event ][ 'border-left' ][ 'color' ] = document.getElementById( 'borderLeftColorfield' ).value;
     css[ event ][ 'border-left' ][ 'style' ] = document.getElementById( 'borderLeftStyle' ).value;
     css[ event ][ 'border-left' ][ 'width' ] = document.getElementById( 'borderLeftWidth' ).value;
    }
    
    // Right border
    if( !document.getElementById( 'borderRight' ).checked ){
     css[ event ][ 'border-right' ][ 'style' ] = '';
     css[ event ][ 'border-right' ][ 'color' ] = '';
     css[ event ][ 'border-right' ][ 'width' ] = '';
    }
    else{
     css[ event ][ 'border-right' ][ 'color' ] = document.getElementById( 'borderRightColorfield' ).value;
     css[ event ][ 'border-right' ][ 'style' ] = document.getElementById( 'borderRightStyle' ).value;
     css[ event ][ 'border-right' ][ 'width' ] = document.getElementById( 'borderRightWidth' ).value;
    }
    
    // Top border
    if( !document.getElementById( 'borderTop' ).checked ){
     css[ event ][ 'border-top' ][ 'style' ] = '';
     css[ event ][ 'border-top' ][ 'color' ] = '';
     css[ event ][ 'border-top' ][ 'width' ] = '';
    }
    else{
     css[ event ][ 'border-top' ][ 'color' ] = document.getElementById( 'borderTopColorfield' ).value;
     css[ event ][ 'border-top' ][ 'style' ] = document.getElementById( 'borderTopStyle' ).value;
     css[ event ][ 'border-top' ][ 'width' ] = document.getElementById( 'borderTopWidth' ).value;
    }
    
    // Bottom border
    if( !document.getElementById( 'borderBottom' ).checked ){
     css[ event ][ 'border-bottom' ][ 'style' ] = '';
     css[ event ][ 'border-bottom' ][ 'color' ] = '';
     css[ event ][ 'border-bottom' ][ 'width' ] = '';
    }
    else{
     css[ event ][ 'border-bottom' ][ 'color' ] = document.getElementById( 'borderBottomColorfield' ).value;
     css[ event ][ 'border-bottom' ][ 'style' ] = document.getElementById( 'borderBottomStyle' ).value;
     css[ event ][ 'border-bottom' ][ 'width' ] = document.getElementById( 'borderBottomWidth' ).value;
    }
    
    // All border
    if( !document.getElementById( 'optAll' ).checked ){
     css[ event ][ 'border' ][ 'style' ] = '';
     css[ event ][ 'border' ][ 'color' ] = '';
     css[ event ][ 'border' ][ 'width' ] = '';
    }
    else{
     css[ event ][ 'border' ][ 'color' ] = document.getElementById( 'borderAllColorfield' ).value;
     css[ event ][ 'border' ][ 'style' ] = document.getElementById( 'borderAllStyle' ).value;
     css[ event ][ 'border' ][ 'width' ] = document.getElementById( 'borderAllWidth' ).value;
    }
    
    // PAGE 3: EXTRAS
    var extraVal = new String( document.getElementById( 'extra' ).value  );
    css[ event ][ 'extra' ] = extraVal.replace( /\n/g, "\\n" );
    return;
   }
   
   
   
   // Update source
   // -------------
   function updateSource(){
    
    // STEP 1: save event values
    saveEventValues();
    
    // STEP 2: UPDATE jso with NORMAL event values
    var jso = window.opener.document.getElementById( '<?php echo $updateId; ?>' );
    if( !jso ) return;
    jso.style.color = css[ 'normal' ]['color'];
    jso.style.backgroundColor = css[ 'normal' ]['background-color'];
    jso.style.fontFamily = css[ 'normal' ]['font-family'];
    jso.style.fontWeight = css[ 'normal' ]['font-bold'] ? 'bold' : 'normal';
    jso.style.fontStyle = css[ 'normal' ]['font-italic'] ? 'italic' : 'normal';
    jso.style.textDecoration = css[ 'normal' ]['font-underline'] ? 'underline' : 'none';
    jso.style.fontSize = css[ 'normal' ]['font-size'] + css[ 'normal' ]['font-size-unit'];    

    // Clear target border values
    jso.style.borderStyle = 'none';

    // Borders - ALL
    if( css[ 'normal' ]['all'] ){
     jso.style.borderColor = css[ 'normal' ][ 'border' ][ 'color' ];
     jso.style.borderWidth = ( css[ 'normal' ][ 'border' ][ 'width' ] * 1 ) + 'px';
     jso.style.borderStyle = css[ 'normal' ][ 'border' ][ 'style' ];
    }
    
    // Borders - Left, Right, Top, Bottom
    if( css[ 'normal' ]['single'] ){
     if( css[ 'normal' ][ 'border-left' ][ 'style' ] ){
      jso.style.borderLeftColor = css[ 'normal' ][ 'border-left' ][ 'color' ];
      jso.style.borderLeftWidth = ( css[ 'normal' ][ 'border-left' ][ 'width' ] * 1 ) + 'px';
      jso.style.borderLeftStyle = css[ 'normal' ][ 'border-left' ][ 'style' ];
     }
     
     if( css[ 'normal' ][ 'border-right' ][ 'style' ] ){
      jso.style.borderRightColor = css[ 'normal' ][ 'border-right' ][ 'color' ];
      jso.style.borderRightWidth = ( css[ 'normal' ][ 'border-right' ][ 'width' ] * 1 ) + 'px';
      jso.style.borderRightStyle = css[ 'normal' ][ 'border-right' ][ 'style' ];
     }
     
     if( css[ 'normal' ][ 'border-top' ][ 'style' ] ){
      jso.style.borderTopColor = css[ 'normal' ][ 'border-top' ][ 'color' ];
      jso.style.borderTopWidth = ( css[ 'normal' ][ 'border-top' ][ 'width' ] * 1 ) + 'px';
      jso.style.borderTopStyle = css[ 'normal' ][ 'border-top' ][ 'style' ];
     }
     
     if( css[ 'normal' ][ 'border-bottom' ][ 'style' ] ){
      jso.style.borderBottomColor = css[ 'normal' ][ 'border-bottom' ][ 'color' ];
      jso.style.borderBottomWidth = ( css[ 'normal' ][ 'border-bottom' ][ 'width' ] * 1 ) + 'px';
      jso.style.borderBottomStyle = css[ 'normal' ][ 'border-bottom' ][ 'style' ];
     }
    }
    
    return;
   }

   
   // Show Div
   // --------
   function showDiv( divId ){
    for( c = 0; c <= 3; c++ ){
     if( divId != 'page' + c ){
      switchDiv( ( 'page' + c ) , 0 );
      if( document.getElementById( 'btnPage' + c ) ){
       setClass( document.getElementById( 'btnPage' + c ), 'btnPage' );
      }
     }
     else{
      if( document.getElementById( 'btnPage' + c ) ){
       setClass( document.getElementById( 'btnPage' + c ), 'btnPageOn' );
      }
     }
     switchDiv( divId, 1 );
    }
    return;
   }

   function updateBorderValues( sourceId ){
    if( document.getElementById( sourceId ).checked ){
     document.getElementById( sourceId + 'Width' ).value = '1';
     document.getElementById( sourceId + 'Style' ).value = 'solid';
    }
    else{
     document.getElementById( sourceId + 'Width' ).value = '';
     document.getElementById( sourceId + 'Style' ).value = 'none';
    }
    return;
   }

   function cancelBorders(){
    document.getElementById( 'optAll' ).checked = 0;
    document.getElementById( 'optSingle' ).checked = 0;

    document.getElementById( 'borderAllColorfield' ).value = '';
    document.getElementById( 'borderAllWidth' ).value = '';
    document.getElementById( 'borderAllStyle' ).value = 'none';
    relateColor('borderAllColor', getObj('borderAllColorfield').value);

    <?php foreach( $borderTypes as $bt => $btval ){ ?>
      document.getElementById( 'border<?=$bt?>' ).checked = 0;
      document.getElementById( 'border<?=$bt?>Colorfield' ).value = '';
      document.getElementById( 'border<?=$bt?>Width' ).value = '';
      document.getElementById( 'border<?=$bt?>Style' ).value = 'none';
      relateColor('border<?=$bt?>Color', getObj('border<?=$bt?>Colorfield').value);
    <?php } ?>
    return;
   }
   
   
   // SWITCH EVENTS
   // -------------
   function switchEvent( activeEvent ){
    
    
    // STEP 1: SAVE EVENT info
    saveEventValues();
    
    // STEP 2: Get new event
    for( c = 0; c <= 3; c++ ){
     if( activeEvent != 'btnEvent' + c ){
      if( document.getElementById( 'btnEvent' + c ) ){
       setClass( document.getElementById( 'btnEvent' + c ), 'btnEvent' );
      }
     }
     else{
      if( document.getElementById( 'btnEvent' + c ) ){
       setClass( document.getElementById( 'btnEvent' + c ), 'btnEventOn' );
       event = events[ c ];
      }
     }
    }
    
    // STEP 3: ReSet page controls
    document.getElementById( 'fontBold' ).checked = 0;           
    document.getElementById( 'fontItalic' ).checked = 0;       
    document.getElementById( 'fontUnderlined' ).checked = 0;
    document.getElementById( 'optSingle' ).checked = 0;
    document.getElementById( 'optAll' ).checked = 0;
    document.getElementById( 'borderLeft' ).checked = 0;
    document.getElementById( 'borderRight' ).checked = 0;
    document.getElementById( 'borderTop' ).checked = 0;
    document.getElementById( 'borderBottom' ).checked = 0;
    document.getElementById( 'borderAllStyle' ).value = 'none';
    document.getElementById( 'borderLeftStyle' ).value = 'none';
    document.getElementById( 'borderRightStyle' ).value = 'none';
    document.getElementById( 'borderTopStyle' ).value = 'none';
    document.getElementById( 'borderBottomStyle' ).value = 'none';
     
    // NOW: update page controls
    document.getElementById( 'fontFamily' ).value = css[ event ][ 'font-family' ];
    document.getElementById( 'fontSize' ).value = css[ event ][ 'font-size' ];
    document.getElementById( 'sizeUnit' ).value = css[ event ][ 'font-size-unit' ];
    
    
    if( css[ event ][ 'font-bold' ] ) document.getElementById( 'fontBold' ).checked = 1;
    if( css[ event ][ 'font-italic' ] ) document.getElementById( 'fontItalic' ).checked = 1;
    if( css[ event ][ 'font-underline' ] ) document.getElementById( 'fontUnderlined' ).checked = 1;
    
    document.getElementById( 'foregroundfield' ).value = css[ event ][ 'color' ];
    document.getElementById( 'backgroundfield' ).value = css[ event ][ 'background-color' ];
    document.getElementById( 'cursor' ).value = css[ event ][ 'cursor' ];
    
    // PAGE 2: BORDERS
    if( css[ event ][ 'all' ] ) document.getElementById( 'optAll' ).checked = 1;
    if( css[ event ][ 'single' ] ) document.getElementById( 'optSingle' ).checked = 1;
    
    if( css[ event ][ 'border-left' ][ 'style' ] ) document.getElementById( 'borderLeft' ).checked = 1;
    if( css[ event ][ 'border-right' ][ 'style' ] ) document.getElementById( 'borderRight' ).checked = 1;
    if( css[ event ][ 'border-top' ][ 'style' ] ) document.getElementById( 'borderTop' ).checked = 1;
    if( css[ event ][ 'border-bottom' ][ 'style' ] ) document.getElementById( 'borderBottom' ).checked = 1;
    
    document.getElementById( 'borderAllColorfield' ).value = css[ event ][ 'border' ][ 'color' ];
    document.getElementById( 'borderAllStyle' ).value = css[ event ][ 'border' ][ 'style' ];
    document.getElementById( 'borderAllWidth' ).value = css[ event ][ 'border' ][ 'width' ];
    
    document.getElementById( 'borderLeftColorfield' ).value = css[ event ][ 'border-left' ][ 'color' ];
    document.getElementById( 'borderLeftStyle' ).value = css[ event ][ 'border-left' ][ 'style' ];
    document.getElementById( 'borderLeftWidth' ).value = css[ event ][ 'border-left' ][ 'width' ];
    
    document.getElementById( 'borderRightColorfield' ).value = css[ event ][ 'border-right' ][ 'color' ];
    document.getElementById( 'borderRightStyle' ).value = css[ event ][ 'border-right' ][ 'style' ];
    document.getElementById( 'borderRightWidth' ).value = css[ event ][ 'border-right' ][ 'width' ];
    
    document.getElementById( 'borderTopColorfield' ).value = css[ event ][ 'border-top' ][ 'color' ];
    document.getElementById( 'borderTopStyle' ).value = css[ event ][ 'border-top' ][ 'style' ];
    document.getElementById( 'borderTopWidth' ).value = css[ event ][ 'border-top' ][ 'width' ];
    
    document.getElementById( 'borderBottomColorfield' ).value = css[ event ][ 'border-bottom' ][ 'color' ];
    document.getElementById( 'borderBottomStyle' ).value = css[ event ][ 'border-bottom' ][ 'style' ];
    document.getElementById( 'borderBottomWidth' ).value = css[ event ][ 'border-bottom' ][ 'width' ];
    
    // PAGE 3: EXTRAS
    document.getElementById( 'extra' ).value = css[ event ][ 'extra' ].replace( /\\n/g, "\n" );
    
    // PAGE 0: Debug
    document.getElementById( 'debug' ).value = css[ event ][ 'cDef' ];
    
    // NOW: update the colors
    relateColor('foreground', getObj('foregroundfield').value);
 	relateColor('background', getObj('backgroundfield').value);
 	relateColor('borderAllColor', getObj('borderAllColorfield').value);
 	relateColor('borderLeftColor', getObj('borderLeftColorfield').value);
 	relateColor('borderRightColor', getObj('borderRightColorfield').value);
 	relateColor('borderTopColor', getObj('borderTopColorfield').value);
 	relateColor('borderBottomColor', getObj('borderBottomColorfield').value);
    
    return;
   }
   
   
   // Save ALL
   function saveAll(){
    
    // Save this event
    saveEventValues();
    
   <?php foreach( $eventList as $event ){ ?>
    document.fake['<?=$event?>-font-family'].value = '"'+css['<?=$event?>']['font-family']+'"';
    document.fake['<?=$event?>-font-size'].value = css['<?=$event?>']['font-size'] + css['<?=$event?>']['font-size-unit'];
    document.fake['<?=$event?>-font-bold'].value = css['<?=$event?>']['font-bold'];
    document.fake['<?=$event?>-font-italic'].value = css['<?=$event?>']['font-italic'];
    document.fake['<?=$event?>-font-underline'].value = css['<?=$event?>']['font-underline'];
    document.fake['<?=$event?>-color'].value = css['<?=$event?>']['color'];
    document.fake['<?=$event?>-background-color'].value = css['<?=$event?>']['background-color'];
    document.fake['<?=$event?>-cursor'].value = css['<?=$event?>']['cursor'];
    
    if( css['<?=$event?>']['all'] && css['<?=$event?>']['border']['style'] != 'none' ){
     document.fake['<?=$event?>-border'].value = css['<?=$event?>']['border']['color'] + ' ' + css['<?=$event?>']['border']['style'] + ' ' + css['<?=$event?>']['border']['width'] + 'px';
    }
    
    if( css['<?=$event?>']['single'] ){
     if( css['<?=$event?>']['border-left']['style'] && css['<?=$event?>']['border-left']['style'] != 'none' ){
      document.fake['<?=$event?>-border-left'].value = css['<?=$event?>']['border-left']['color'] + ' ' + css['<?=$event?>']['border-left']['style'] + ' ' + css['<?=$event?>']['border-left']['width'] + 'px';
     }
     
     if( css['<?=$event?>']['border-right']['style'] && css['<?=$event?>']['border-right']['style'] != 'none' ){
      document.fake['<?=$event?>-border-right'].value = css['<?=$event?>']['border-right']['color'] + ' ' + css['<?=$event?>']['border-right']['style'] + ' ' + css['<?=$event?>']['border-right']['width'] + 'px';
     }
     
     if( css['<?=$event?>']['border-top']['style'] && css['<?=$event?>']['border-top']['style'] != 'none' ){
      document.fake['<?=$event?>-border-top'].value = css['<?=$event?>']['border-top']['color'] + ' ' + css['<?=$event?>']['border-top']['style'] + ' ' + css['<?=$event?>']['border-top']['width'] + 'px';
     }
     
     if( css['<?=$event?>']['border-bottom']['style'] && css['<?=$event?>']['border-bottom']['style'] != 'none' ){
      document.fake['<?=$event?>-border-bottom'].value = css['<?=$event?>']['border-bottom']['color'] + ' ' + css['<?=$event?>']['border-bottom']['style'] + ' ' + css['<?=$event?>']['border-bottom']['width'] + 'px';
     }
    }
    document.fake['<?=$event?>-extra'].value = css['<?=$event?>']['extra'];
   <?php } ?>
    
    document.fake.action='./saveCSS.php'
    document.fake.submit();
    return true;
    
    
    
    // Done reload source page
    window.opener.location.reload();
    window.close();
    return true;
   }
   
   
    function updateAll( cssProperty, objectId ){
        if( event == 'normal' ){
            var old_value = css[ 'normal' ][ cssProperty ];
            alert( 'Here' );
            for( var i = 0; i < events.length; i++ ){
                if( css[ events[ i ] ][ cssProperty ] == old_value ){
                    
                    if( document.getElementById( objectId ).type == 'checkbox' ){
                        css[ events[ i ] ][ cssProperty ] = document.getElementById( objectId ).checked;
                    }
                    else{
                        css[ events[ i ] ][ cssProperty ] = document.getElementById( objectId ).value;
                    }
                }
            }
        }
        return;
    }
   
  // -->
  </SCRIPT>

 </HEAD>
 <STYLE>
 <!--
  BODY{
   font-family: Tahoma;
   font-size: 12px;
   background-color: silver;
  }

  TABLE{
   font-family: Tahoma;
   font-size: 12px;
  }

  #buttons{
   text-align: left;
   padding: 0px;
   margin-bottom: 1px;
   width: 100%;
  }

  INPUT.btnPage{
   border: black solid 1px;
  }

  INPUT.btnPageOn{
   border: black solid 1px;
   background-color: gray;
   color: white;
  }
  
  #events{
   padding-top: 20px;
  }
  
  INPUT.btnEvent{
   margin: 2px;
   border: black solid 1px;
   background-color: #C0C0ff;   
   width: 60px;
  }
  
  INPUT.btnEventOn{
   margin: 2px;
   border: black solid 1px;
   background-color: #8080e0;   
   width: 60px;
   color: white;
  }

  #page1{
   positioning: relative;
  }

  #page0{
   positioning: absolute;
   display: none;
  }

  #page2{
   positioning: absolute;
   display: none;
  }

  #page3{
   positioning: absolute;
   display: none;
  }

  DIV.page{
   background-color: #e8e8e8;
   height: 300px;
   border: gray solid 1px;
  }

  DIV.colorPicker{
   border: 1px solid gray;
   font: 10px Verdana;
   text-decoration: none;
   width: 14px;
   height: 14px;
   float: left;
   cursor: pointer;
   margin-right: 4px;
   margin-top: 1px;
  }

  INPUT.colorValue{
   border: 1px solid black;
   font: 12px Verdana;
   background-color: white;
  }

  TD.label{
   text-align: right;
   padding-left: 16px;
   padding-right: 2px;
  }

  #extra{
   width: 478px;
   height: 298px;
   border-style: none;
  }

  #debug{
   width: 478px;
   height: 298px;
   border-style: none;
  }

  INPUT.button{
   font-family: Verdana;
   font-size: 11px;
   border: black solid 1px;
   cursor: pointer;
  }
  
  FORM.fake{
   display: none;
  }

 -->
 </STYLE>

 <CENTER>
  <?php echo $updateId; ?>::<?php echo $editType; ?> <?php echo $subClass.".".$className; ?><BR><BR>

  <TABLE border="0" cellspacing="0" cellpadding="0">
   <TR valign="top">
    <TD style="width: auto;">
     <DIV id="events">
      <?php if( in_array( 'normal', $eventList ) ){ ?><INPUT id="btnEvent0" class="btnEventOn" type="button" value="Normal" onclick="switchEvent( this.id );"><BR><?php } ?>
      <?php if( in_array( 'hover', $eventList ) ){ ?><INPUT id="btnEvent1" class="btnEvent" type="button" value="Hover" onclick="switchEvent( this.id );"><BR><?php } ?>
      <?php if( in_array( 'active', $eventList ) ){ ?><INPUT id="btnEvent2" class="btnEvent" type="button" value="Active" onclick="switchEvent( this.id );"><BR><?php } ?>
      <?php if( in_array( 'visited', $eventList ) ){ ?><INPUT id="btnEvent3" class="btnEvent" type="button" value="Visited" onclick="switchEvent( this.id );"><BR><?php } ?>
     </DIV>
     <DIV style="padding-top: 40px;">
      <INPUT class="btnEvent" type="button" value="Save" onclick="return saveAll();" style="background-color: #C0FFC0; font-weight: bold;">
     </DIV>
    </TD>
    
    <TD align="center" style="width: 480px;"> 
     <!-- pages -->
     <DIV id="buttons">
      <DIV width="70%">
       <INPUT id="btnPage1" class="btnPageOn" type="button" value="Font" onclick="showDiv( 'page1' ); document.getElementById('fontFamily').focus();">
       <?php if( $displayBordersDiv ){ ?><INPUT id="btnPage2" class="btnPage" type="button" value="Borders" onclick="showDiv( 'page2' );"><?php } ?>
       <?php if( $displayExtraDiv ){ ?><INPUT id="btnPage3" class="btnPage" type="button" value="Extra" onclick="showDiv( 'page3' ); document.getElementById('extra').focus();"><?php } ?>
       <?php if( $displayDebugDiv ){ ?><INPUT id="btnPage0" class="btnPage" type="button" value="Debug" onclick="showDiv( 'page0' ); document.getElementById('debug').focus();"><?php } ?>
       <!-- &nbsp;<INPUT id="btnApply" class="btnPage" type="button" value="Apply" disabled onclick="updateSource();"> -->
      </DIV>
      
      
      
      
      
     </DIV>
   
   
     <DIV id="page1" class="page">
      <BR>
      <TABLE border="0" cellspacing="0" cellpadding="0">
   
       <!-- Font -->
       <TR>
        <TD class="label">Font:</TD>
        <TD>
         <SELECT id="fontFamily" style="width: 120px;" onchange="updateAll( 'font-family', this.id );">
          <?php foreach( $fonts as $fontCaption => $fontValue ){ ?>
          <OPTION value="<?php echo $fontValue; ?>"<?php if( strtolower( $fontValue ) == strtolower( $jscss['normal']['font-family'] ) ) echo ' selected'; ?>><?php echo $fontCaption; ?></OPTION>
          <?php } ?>
         </SELECT>
        </TD>
   
        <!-- font size -->
        <TD class="label">
         Size: <INPUT type="text" id="fontSize" size="3" value="<?php echo $jscss['normal']['font-size']; ?>" onchange="updateAll( 'font-size', this.id );">
        </TD>
        <TD>
         <SELECT id="sizeUnit" onchange="updateAll( 'font-size-unit', this.id );">
          <OPTION value="px" <?php if( $jscss['normal']['font-size-unit'] == 'px' ) echo 'selected'; ?>>px</OPTION>
          <OPTION value="pt" <?php if( $jscss['normal']['font-size-unit'] == 'pt' ) echo 'selected'; ?>>pt</OPTION>
          <OPTION value="em" <?php if( $jscss['normal']['font-size-unit'] == 'em' ) echo 'selected'; ?>>em</OPTION>
         </SELECT>
        </TD>
   
       <!-- Bold -->
        <TD class="label"><LABEL for="fontBold"><B>B</B></LABEL></TD>
        <TD>
         <INPUT type="checkbox" id="fontBold" name="fontBold" <?php echo $jscss['normal']['font-bold']; ?> onchange="updateAll( 'font-bold', this.id );">
        </TD>
   
       <!-- Italic -->
        <TD class="label"><LABEL for="fontItalic"><B><I>I</I></B></LABEL></TD>
        <TD>
         <INPUT type="checkbox" id="fontItalic" name="fontItalic" <?php echo $jscss['normal']['font-italic']; ?> onchange="updateAll( 'font-italic', this.id );">
        </TD>
   
        <!-- Underline -->
        <TD class="label"><LABEL for="fontUnderlined"><U>U</U></LABEL></TD>
        <TD>
         <INPUT type="checkbox" id="fontUnderlined" name="fontUnderlined" <?php echo $jscss['normal']['font-underline']; ?> onchange="updateAll( 'font-underline', this.id );">
        </TD>
   
       </TR>
      </TABLE>
      <BR>
   
      <TABLE border="0" cellspacing="1" cellpadding="0">
       <!-- Color -->
       <TR>
        <TD>Color:</TD>
        <TD>
         <DIV id="foreground" class="colorPicker" onclick="javascript:pickColor( 'foreground' );"></DIV>
         <INPUT id="foregroundfield" 
                class="colorValue" 
                size="8" 
                onchange="relateColor('foreground', this.value);" 
                title="color" 
                name="foregroundColor" 
                value="<?php echo $jscss['normal']['color']; ?>">
        </TD>
       </TR>
   
       <!-- Background color -->
       <TR>
        <TD>Background color:</TD>
        <TD>
         <DIV id="background" class="colorPicker" onclick="javascript:pickColor( 'background' );"></DIV>
         <INPUT id="backgroundfield" 
                class="colorValue" 
                size="8" 
                onchange="relateColor('background', this.value);" 
                title="color" 
                name="backgroundColor" 
                value="<?php echo $jscss['normal']['background-color']; ?>">
        </TD>
       </TR>
   
       <!-- Mouse pointer -->
       <TR>
        <TD>Mouse pointer:</TD>
        <TD>
         <SELECT name="cursor" id="cursor">
          <?php foreach( $cursorPointres as $cp => $cpVal ){ ?>
          <OPTION value="<?=$cpVal?>" <?php if( $cpVal == $jscss['normal']['cursor'] ) echo "selected"; ?>><?php echo $cp; ?></OPTION>
          <?php } ?>
         </SELECT>
        </TD>
       </TR>
   
     	</TABLE>
     </DIV>
   
   
     <!-- Page 2: BORDERS -->
     <DIV id="page2" class="page">
      <BR>
   
   
      <TABLE border="0" cellspacing="2" cellpadding="0" width="90%">
   
       <!-- All -->
       <TR valign="top">
        <TD width="20%"><INPUT type="checkbox" name="optBorderAll" id="optAll" <?php if( $selBorderAll == 'yes' ) echo "checked"; ?>><LABEL for="optAll">All</LABEL></TD>
        <TD>
         <TABLE border="0" cellspacing="2" cellpadding="0">
          <TR>
           <TD width="80">&nbsp;</TD>
           <TD>Color:</TD>
           <TD>Style:</TD>
           <TD>Width:</TD>
          </TR>
   
          <!-- borders -->
          <TR>
           <TD>&nbsp;</TD>
           <TD>
            <DIV id="borderAllColor" class="colorPicker" onclick="javascript:pickColor( 'borderAllColor' );"></DIV>
            <INPUT id="borderAllColorfield" class="colorValue" size="8" onchange="relateColor('borderAllColor', this.value);" title="color" name="borderAllColorColor" value="<?php echo $jscss['normal']['border']['color']; ?>">
           </TD>
           <TD>
            <SELECT id="borderAllStyle">
            <?php foreach( $borderStyles as $borderStyle => $borderStyleValue ){ ?>
             <OPTION value="<?php echo $borderStyleValue; ?>"><?php echo $borderStyle; ?></OPTION>
            <?php } ?>
            </SELECT>
           </TD>
           <TD><INPUT type="text" class="colorValue" id="borderAllWidth" size="2" value="<?php echo $jscss['normal']['border']['width'] ?>"> px</TD>
          </TR>
         </TABLE>
        </TD>
       </TR>
   
       <!-- Defined -->
       <TR valign="top">
        <TD width="20%"><INPUT type="checkbox" name="optBorderSingle" id="optSingle" <?php if( $selBorderSingle == 'yes' ) echo "checked"; ?>><LABEL for="optSingle">One-by-one</LABEL></TD>
        <TD>
         <TABLE border="0" cellspacing="2" cellpadding="0">
          <TR>
           <TD width="80">&nbsp;</TD>
           <TD>Color:</TD>
           <TD>Style:</TD>
           <TD>Width:</TD>
          </TR>
   
          <!-- borders -->
          <?php foreach( $borderTypes as $bt => $btval ){ ?>
          <TR>
           <TD class="caption">
            <INPUT type="checkbox" id="border<?=$bt?>" onclick="updateBorderValues( this.id )"><LABEL for="border<?=$bt?>"><?php echo $bt; ?></LABEL>
           </TD>
           <TD>
            <DIV id="border<?=$bt?>Color" class="colorPicker" onclick="javascript:pickColor( 'border<?=$bt?>Color' );"></DIV>
            <INPUT id="border<?=$bt;?>Colorfield" class="colorValue" size="8" onchange="relateColor('border<?=$bt?>Color', this.value);" title="color" name="border<?=$bt?>ColorColor" value="<?php echo $jscss['normal']['border-'.$btval]['color']; ?>">
           </TD>
           <TD>
            <SELECT id="border<?=$bt?>Style">
            <?php foreach( $borderStyles as $borderStyle => $borderStyleValue ){ ?>
             <OPTION value="<?php echo $borderStyleValue; ?>"><?php echo $borderStyle; ?></OPTION>
            <?php } ?>
            </SELECT>
           </TD>
           <TD><INPUT type="text" class="colorValue" id="border<?=$bt?>Width" size="2" value="<?php echo $jscss['normal']['border-'.$btval]['width'] ?>"> px</TD>
          </TR>
          <?php } ?>
         </TABLE>
   
        </TD>
       </TR>
   
       <!-- none -->
       <TR valign="top">
        <TD width="20%"><!-- commands -->
         <INPUT type="button" class="button" name="btnBorderClear" value="Clear" onclick="cancelBorders();"><BR></TD>
        <TD>&nbsp;</TD>
       </TR>
   
      </TABLE>
     </DIV>
   
     <!-- Page 3: Extra css -->
     <DIV id="page3" class="page">
     	<TEXTAREA name="extra" id="extra"><?php echo trim( str_replace( "\\n", "\n", $jscss['normal']['extra'] ) ); ?></TEXTAREA>
     </DIV>
   
     <!-- Page 0: Debug info -->
     <DIV id="page0" class="page">
     	<TEXTAREA name="debug" id="debug"><?php echo str_replace( '; ', ";\n", $jscss['normal']['cDef']); ?></TEXTAREA>
     </DIV>
     
     <!-- END: pages -->
    </TD>
   </TR> 
  </TABLE>

	</CENTER>

	<SCRIPT language="javascript">
 	<!--
 	 relateColor('foreground', getObj('foregroundfield').value);
 	 relateColor('background', getObj('backgroundfield').value);
 	 relateColor('borderAllColor', getObj('borderAllColorfield').value);

 	 <?php if( $jscss['normal']['border']['style'] ){ ?>
 	  document.getElementById( 'borderAllStyle' ).value = '<?php echo $jscss['normal']['border']['style']; ?>';
 	 <?php } ?>

 	 <?php
 	 foreach( $borderTypes as $bt => $btval ){
  	 if( $jscss['normal']['border-'.$btval]['style'] ){
  	  echo "relateColor('border".$bt."Color', getObj('border".$bt."Colorfield').value); \n";
  	  echo "document.getElementById( 'border".$bt."' ).checked = 1; \n";
  	  echo "document.getElementById( 'border".$bt."Style' ).value = '".$jscss['normal']['border-'.$btval]['style']."'; \n";
  	 }
  	}
 	 ?>

 	// -->
 </SCRIPT>
 
 <!-- Used for faked submission -->
 <FORM class="fake" name="fake" method="post">
  
  <?php
   switch( $classOrId ){
   case 'class':
    $editId = "$subClass.$className";
    break;
   
   case 'tag':
    $editId = $className;
    break;
   
   case 'id':
    $editId = "#$className";
    break;
   }
  ?>
  
  <INPUT type="hidden" name="editId" value="<?=$editId?>">
  <INPUT type="hidden" name="eventList" value="<?php echo implode( ' ', $eventList ); ?>">
  <INPUT type="hidden" name="skin" value="<?php echo $_REQUEST['skin']; ?>">
  
  <?php foreach( $eventList as $event ){ ?>
   <INPUT type="hidden" name="<?php echo $event; ?>-font-family" value="">
   <INPUT type="hidden" name="<?php echo $event; ?>-font-size" value="">
   <INPUT type="hidden" name="<?php echo $event; ?>-font-bold" value="">
   <INPUT type="hidden" name="<?php echo $event; ?>-font-italic" value="">
   <INPUT type="hidden" name="<?php echo $event; ?>-font-underline" value="">
   <INPUT type="hidden" name="<?php echo $event; ?>-color" value="">
   <INPUT type="hidden" name="<?php echo $event; ?>-background-color" value="">
   <INPUT type="hidden" name="<?php echo $event; ?>-cursor" value="">
   <INPUT type="hidden" name="<?php echo $event; ?>-border" value="">
   <INPUT type="hidden" name="<?php echo $event; ?>-border-left" value="">
   <INPUT type="hidden" name="<?php echo $event; ?>-border-right" value="">
   <INPUT type="hidden" name="<?php echo $event; ?>-border-top" value="">
   <INPUT type="hidden" name="<?php echo $event; ?>-border-bottom" value="">
   <INPUT type="hidden" name="<?php echo $event; ?>-extra" value="">
  <?php } ?>
 </FORM>
</HTML>

